# Creating your event

First decide your events name e.g. MyEvent
```
App.Events.MyEvent = class MyEvent extends App.Events.BaseEvent {
	// The event only fires if the optional conditions listed in this array are meet however it can be empty.
	eventPrerequisites() {
			// Conditional example
			return [
				() => V.plot === 1
			];
			
			// empty example
			return [];
	}

	// Each position in the array correlates to conditions that a slave must meet to be selected however it can be empty.
	actorPrerequisites() {
		// Single slave example
		return [
			[
				s => canWalk(s),
				s => s.fetish !== "mindbroken",
				s => s.devotion >= 50,
				s => s.trust <= 20
			]
		];
		
		// Dual slave
		return [
			[
				s => s.ID === getSlave(this.actors[0]).mother
			]
		];
		// The second actor to be the first actor's mother.
		
		// empty example
		return [[]];
	}

	execute(node) {
		/** @type {Array<App.Entity.SlaveState>} */
		let [eventSlave] = this.actors.map(a => getSlave(a));
		const {
			He, he, His, his, him, himself
		} = getPronouns(eventSlave);
		const {
			HeU, heU, hisU, himU, himselfU
		} = getNonlocalPronouns(V.seeDicks).appendSuffix('U');
		
		// V.nextButton is shown to the user on the side bar, e.g. V.nextButton = "Continue";
		// V.nextLink is the next passge that will be executed, e.g. V.nextLink = "Economics";

		// show slave Art
		App.Events.drawEventArt(node, eventSlave, "no clothing");

		let t = [];
		
		t.push(`Event info text goes here`)
		
		App.Events.addParagraph(node, t);

		// Event branches
		App.Events.addResponses(node, [
			new App.Events.Result(`Text shown to user`, choiceA),
			...
		]);

		function choiceA() {
			t = [];

			t.push(`choice text goes here`);

			// additional code if need

			// effect on slave e.g.
			eventSlave.devotion += 4;
			eventSlave.trust += 4;
			return t;
		}
	}
};
```
# Adding your event to the pool

Now that your event has been created it needs to be added to the pool of possible events for it's type which for most
 events, as well as for our example, is random individual event. 
This pool can be found at src/events/randomEvent.js. 
Simply add your event to the array in App.Events.getIndividualEvents.

# Testing

You can go to the "options page" either sideBar -> Options -> "Game Options" or the "O" key by default.
Then go to the Debug & cheating tab and enable CheatMode.
Once you get to "Random Individual Event" select any slave and at the bottom under DEBUG: there should be
 a input box with "Check Prerequisites and Casting" link next to it.
Per the example under it, place your event's full name into it e.g. App.Events.myEvent and then hit said link.
If everything works as intended you should see output 